﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace ZweiHauptfenster
{
    // Anwendungskontext für zwei Hauptfenster 
    class DualApplicationContext : ApplicationContext
    {
        private int formCount;
        private Form1 form1;
        private Form2 form2;

        public DualApplicationContext()
        {
            formCount = 0;

            form1 = new Form1();
            form1.Closed += new EventHandler(OnFormClosed);
            formCount++;

            form2 = new Form2();
            form2.Closed += new EventHandler(OnFormClosed);
            formCount++;

            // Formulare anzeigen
            form1.Show();
            form2.Show();
        }

        private void OnFormClosed(object sender, EventArgs e)
        {
            formCount--;
            if (formCount == 0)
            {
                ExitThread();   // Anwendung beenden
            }
        }

    }

    static class Program
    {
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            DualApplicationContext context = new DualApplicationContext();
            Application.Run(context);
        }
    }
}
