using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Datenbindung
{
    public partial class Form1 : Form
    {
        enum Towns { Amsterdam, Berlin, Oslo, Paris };
        Figure[] cast;
        List<Figure> cast2;
        List<Figure> cast3;
        BindingSource bs;
       
        Customer jim;
        
        public Form1()
        {            
            InitializeComponent();
            
            tabControl1.SelectedIndex = 6;
            
            
        /*** Code fr Registerseite KOMPONENTEN 1 ***/
            
            lb_1_1.DataBindings.Add("Text", tb_1_1, "Text");
            tb_1_1.Select();


            
        /*** Code fr Registerseite KOMPONENTEN 2 ***/
            
            // TextBox binden
            tb_2_1.DataBindings.Add("Text", this, "ClientSize");  
            
            // Bindung mit selbst definierter Parse-Formatierung
            Binding bnd1 = new Binding("Text", this, "Size", false);
            bnd1.Parse += new ConvertEventHandler(SizeStringToSize);
            tb_2_2.DataBindings.Add(bnd1);
            
            // weitere Bindungen
            tb_2_3.DataBindings.Add("Text", this, "Text", false, DataSourceUpdateMode.OnPropertyChanged);      
            tb_2_4.DataBindings.Add("Text", this, "Opacity", true, DataSourceUpdateMode.Never);      
            
            // Bindung der Bildlaufleiste
            sb_2_1.Value = 100;
            Binding bnd2 = new Binding("Opacity", sb_2_1, "Value");
            bnd2.Format += new ConvertEventHandler(IntToPercent);
            this.DataBindings.Add(bnd2);
            
            

        /*** Code fr Registerseite OBJEKTE ***/
            
            // Objekt erzeugen und Daten in Labels laden
            jim = new Customer("Jim", "Meininger", "HLQ_305");
            lb_3_5.Text = jim.Firstname;
            lb_3_6.Text = jim.Lastname;
            lb_3_7.Text = jim.ID;
            
            // Bindung an Objekteigenschaft
            tb_3_1.DataBindings.Add("Text", jim, "ID");
            
            

        /*** Code fr Registerseiten ARRAYS I und II ***/
            
            cast = new Figure[3];
            cast[0] = new Figure("Detektiv", "Peter Falk");
            cast[1] = new Figure("Mrder", "Anthony Perkins");
            cast[2] = new Figure("Opfer", "Drew Barrymoore");

            // ARRAYS I
            lb_4_6.Text = cast[0].Figurename;
            lb_4_7.Text = cast[1].Figurename;
            lb_4_8.Text = cast[2].Figurename;
             
            tb_4_1.DataBindings.Add("Text", cast[2], "Figurename");
            
            
            // ARRAYS II
            bs = new BindingSource();
            foreach (Figure f in cast)
              bs.Add(f);

            tb_5_1.DataBindings.Add("Text", bs, "Figurename");
            tb_5_2.DataBindings.Add("Text", bs, "Playersname");
  
           
            
        /*** Code fr Registerseite AUFLISTUNGEN ***/
            cast2 = new List<Figure>(3);
            cast2.Add(new Figure("Detektiv", "Peter Falk"));
            cast2.Add(new Figure("Mrder", "Anthony Perkins"));
            cast2.Add(new Figure("Opfer", "Drew Barrymoore"));
                        
            bindingSource1.DataSource = cast2;
            tb_6_1.DataBindings.Add("Text", bindingSource1, "Figurename");
            tb_6_2.DataBindings.Add("Text", bindingSource1, "Playersname");
  
           
            
        /*** Code fr Registerseite LISTBOX ***/
            
            cast3 = new List<Figure>(3);
            cast3.Add(new Figure("Detektiv", "Peter Falk"));
            cast3.Add(new Figure("Mrder", "Anthony Perkins"));
            cast3.Add(new Figure("Opfer", "Drew Barrymoore"));
            
            listBox_7_1.DataSource = cast3;
            listBox_7_1.DisplayMember = "Figurename";
            listBox_7_1.ValueMember = "Playersname";
            
            tb_7_1.DataBindings.Add("Text", listBox_7_1, "SelectedIndex", true, DataSourceUpdateMode.OnPropertyChanged);
            lb_7_1.DataBindings.Add("Text", listBox_7_1, "SelectedValue", false, DataSourceUpdateMode.Never);
            
            
        }
        

        private void SizeStringToSize(object sender, ConvertEventArgs e)
        {
            if (e.DesiredType != typeof(Size)) 
                return;

            e.Value = (Size) new SizeConverter().ConvertFromString(e.Value.ToString());
        }
        private void IntToPercent(object sender, ConvertEventArgs e)
        {    
            if (e.DesiredType != typeof(Double)) 
                return;

            double d = (Int32) e.Value / 100.0;
            e.Value = d;
        }


        private void btn_3_1_Click(object sender, EventArgs e)
        {
            jim.ID = jim.ID + "1";              
            lb_3_7.Text = jim.ID;
        }

        private void btn_3_2_Click(object sender, EventArgs e)
        {
            lb_3_5.Text = jim.Firstname;
            lb_3_6.Text = jim.Lastname;
            lb_3_7.Text = jim.ID;
        }

        private void btn_4_1_Click(object sender, EventArgs e)
        {
            if (String.Compare(cast[2].Figurename, 0, "Opf", 0, 3) == 0)
            {
                cast[2].Figurename = "Verdchtiger";
                btn_4_1.Text = "Verdchtiger -> Opfer";
            }
            else
            {
                cast[2].Figurename = "Opfer";
                btn_4_1.Text = "Opfer -> Verdchtiger";
            }
            lb_4_8.Text = cast[2].Figurename;
            tb_4_1.DataBindings["Text"].ReadValue();
        }

        private void btn_4_2_Click(object sender, EventArgs e)
        {
            lb_4_6.Text = cast[0].Figurename;
            lb_4_7.Text = cast[1].Figurename;
            lb_4_8.Text = cast[2].Figurename;
        }

        private void btn_5_1_Click(object sender, EventArgs e)
        {
            bs.MoveNext();
        }

        private void btn_5_2_Click(object sender, EventArgs e)
        {
            bs.MovePrevious();
        }

        private void btn_5_3_Click(object sender, EventArgs e)
        {
            if (String.Compare(cast[0].Playersname, 0, "Pet", 0, 3) == 0)
            {
                cast[0].Playersname = "Humphrey Bogart";
            }
            else
            {
                cast[0].Playersname = "Peter Falk";
            }
            tb_5_2.DataBindings["Text"].ReadValue();
        }
        
        private void btn_6_1_Click(object sender, EventArgs e)
        {
            if (String.Compare(cast2[0].Playersname, 0, "Pet", 0, 3) == 0)
            {
                cast2[0].Playersname = "Humphrey Bogart";
            }
            else
            {
                cast2[0].Playersname = "Peter Falk";
            }
            tb_6_2.DataBindings["Text"].ReadValue();
        }

        private void btn_7_1_Click(object sender, EventArgs e)
        {
            listBox_7_1.BindingContext[cast3].SuspendBinding();
            
            if (String.Compare(cast3[0].Playersname, 0, "Pet", 0, 3) == 0)
            {
                cast3[0] = new Figure("Kommissar", "Lino Ventura");
            }
            else
            {
                cast3[0] = new Figure("Detektiv", "Peter Falk");
            }
            listBox_7_1.SelectedIndex = 0;
            
            listBox_7_1.BindingContext[cast3].ResumeBinding();
        }

    }
}