using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Laufleisten
{
    public partial class Form1 : Form
    {
        PictureBox myPictureBox;
        VScrollBar myVScrollBar;
        TrackBar myTrackBar;
        Label myLabel;
        
        public Form1()
        {
            this.Text = "Laufleisten";
            this.Size = new Size(500, 250);
            
            myPictureBox = new PictureBox();
            myPictureBox.Parent = this;
            myPictureBox.Image = Image.FromFile("..\\..\\castle.bmp");
            myPictureBox.Location = new Point(40, 30);
            myPictureBox.Paint += new PaintEventHandler(myPictureBox_Paint);
            
            myVScrollBar = new VScrollBar();
            myVScrollBar.Parent = myPictureBox;
            myVScrollBar.Dock = DockStyle.Right;
            myVScrollBar.Value = 0;
            myVScrollBar.Minimum = 0;
            myVScrollBar.Maximum = myPictureBox.Image.Height - 1;
            
            myPictureBox.Size = new Size(myPictureBox.Image.Width + myVScrollBar.Width, 100);
            
            myVScrollBar.SmallChange = 1;
            myVScrollBar.LargeChange = myPictureBox.Height;
            myVScrollBar.Scroll += new ScrollEventHandler(myVScrollBar_Scroll);  
            
            
            
            
            
            myTrackBar = new TrackBar();
            myTrackBar.Parent = this;
            myTrackBar.Location = new Point(40, 150);
            myTrackBar.Size = new Size(400, 40);
            myTrackBar.Orientation = Orientation.Horizontal;
            myTrackBar.Minimum = -10;
            myTrackBar.Maximum = +10;
            myTrackBar.Value = 0;
            myTrackBar.TickFrequency = 2;
            
            myLabel = new Label();
            myLabel.Parent = this;
            myLabel.Location = new Point(450, 150);
            myLabel.DataBindings.Add("Text", myTrackBar, "Value", true, DataSourceUpdateMode.Never);
        }
        
        private void myVScrollBar_Scroll(Object sender, ScrollEventArgs se)
        {
            myPictureBox.Refresh();
        }

        private void myPictureBox_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(myPictureBox.Image, 
                        new Rectangle(0, 0, myPictureBox.Right - myVScrollBar.Width, 
                                      myPictureBox.Height), 
                        new Rectangle(0, myVScrollBar.Value, 
                                      myPictureBox.Right - myVScrollBar.Width,
                                      myPictureBox.Height), 
                        GraphicsUnit.Pixel);
        }

    }
}