using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Menue_Symbolleiste
{
    public partial class Form1 : Form
    {
        private MenuStrip myMenuStrip;
        private ToolStrip myToolStrip;
        private StatusStrip myStatusStrip;
        
        ToolStripStatusLabel sbField1, sbField2;

        private Timer clockTimer;        
        
        
        public Form1()
        {
            InitializeComponent();
            
            
            // Menleiste erzeugen und in Formular einfgen
            myMenuStrip = new MenuStrip();
            myMenuStrip.Dock = DockStyle.Top;

            // Einzelnes Men erstellen und mit Menbefehlen fllen
            ToolStripMenuItem file = new ToolStripMenuItem("Datei");
            ToolStripMenuItem fileNew = new ToolStripMenuItem("Neu", null, fileNew_Click);            
            ToolStripMenuItem fileOpen = new ToolStripMenuItem("ffnen", null, fileOpen_Click);
            ToolStripMenuItem fileSave = new ToolStripMenuItem("Speichern", null, fileSave_Click);
            ToolStripMenuItem fileQuit = new ToolStripMenuItem("Beenden", null, fileQuit_Click);
            
            // Untersttzung fr Statusleiste
            fileNew.MouseHover += menuItem_MouseHover;
            fileNew.MouseLeave += menuItem_MouseLeave;
            fileOpen.MouseHover += menuItem_MouseHover;
            fileOpen.MouseLeave += menuItem_MouseLeave;
            fileSave.MouseHover += menuItem_MouseHover;
            fileSave.MouseLeave += menuItem_MouseLeave;
            fileQuit.MouseHover += menuItem_MouseHover;
            fileQuit.MouseLeave += menuItem_MouseLeave;
                                   
                        
            file.DropDownItems.AddRange(new ToolStripItem[] {fileNew, fileOpen, fileSave, 
                                                             new ToolStripSeparator(),
                                                             fileQuit});
                                                    
            // Men in Menleiste einfgen
            myMenuStrip.Items.Add(file);



            // Symbolleiste erzeugen 
            myToolStrip = new ToolStrip();
            myToolStrip.Dock = DockStyle.Top;

            // Symbolleiste mit Symbolschaltflchen fllen
            ToolStripButton btnFileNew = new ToolStripButton();
                            btnFileNew.Image = Menue_Symbolleiste.Properties.Resources.NewDocument;
                            btnFileNew.ImageTransparentColor = Color.Magenta;
                            btnFileNew.Click += fileNew_Click;
                            btnFileNew.ToolTipText = "Neu";
                            btnFileNew.MouseHover += menuItem_MouseHover;
                            btnFileNew.MouseLeave += menuItem_MouseLeave;
            ToolStripButton btnFileOpen = new ToolStripButton();
                            btnFileOpen.Image = Menue_Symbolleiste.Properties.Resources.OpenFolder;
                            btnFileOpen.ImageTransparentColor = Color.Magenta;
                            btnFileOpen.ToolTipText = "ffnen";
                            btnFileOpen.Click += fileOpen_Click;
                            btnFileOpen.MouseHover += menuItem_MouseHover;
                            btnFileOpen.MouseLeave += menuItem_MouseLeave;
            ToolStripButton btnFileSave = new ToolStripButton();
                            btnFileSave.Image = Menue_Symbolleiste.Properties.Resources.Save;
                            btnFileSave.ImageTransparentColor = Color.Magenta;
                            btnFileSave.ToolTipText = "Speichern";
                            btnFileSave.Click += fileSave_Click;
                            btnFileSave.MouseHover += menuItem_MouseHover;
                            btnFileSave.MouseLeave += menuItem_MouseLeave;
                       
            myToolStrip.Items.AddRange(new ToolStripItem[] {btnFileNew, btnFileOpen, 
                                                            btnFileSave});
                  
            // Symbolleiste in Formular einfgen
            //this.Controls.Add(myToolStrip);                                  
            //this.Controls.Add(myMenuStrip);         
            myMenuStrip.GripStyle = ToolStripGripStyle.Visible;  
            
            
            ToolStripContainer myToolStripContainer = new ToolStripContainer();
            myToolStripContainer.Parent = this;
            myToolStripContainer.Dock = DockStyle.Fill;
                             
            myToolStripContainer.TopToolStripPanel.Controls.Add(myToolStrip);
            myToolStripContainer.TopToolStripPanel.Controls.Add(myMenuStrip);
            
            
            myStatusStrip = new StatusStrip();
            myStatusStrip.Parent = this;
            myStatusStrip.Dock = DockStyle.Bottom;
            
            sbField1 = new ToolStripStatusLabel();
            sbField1.Spring = true;
            sbField1.TextAlign = ContentAlignment.MiddleLeft;
            sbField2 = new ToolStripStatusLabel();
            sbField2.AutoSize = true;
                                 
            myStatusStrip.Items.AddRange(new ToolStripItem[] {
                                         sbField1, 
                                         new ToolStripSeparator(),
                                         sbField2 });
            
            sbField1.Text = "";  
            sbField2.Text = DateTime.Now.ToShortTimeString();
            
            
            clockTimer = new Timer();
            clockTimer.Interval = 10000;
            clockTimer.Tick += new EventHandler(this.OnTimer);
            clockTimer.Start();
            
        }
        
private void menuItem_MouseHover(object sender, EventArgs e)
{
    if (sender is ToolStripMenuItem)
    {
        sbField1.Text = ((ToolStripMenuItem)sender).Text;
    }
    if (sender is ToolStripButton)
    {
        sbField1.Text = ((ToolStripButton)sender).ToolTipText;
    }

}

private void menuItem_MouseLeave(object sender, EventArgs e)
{
    sbField1.Text = "";
}
        
    private void OnTimer(object sender, EventArgs args)
    {
        sbField2.Text = DateTime.Now.ToShortTimeString();           
    }

        // Die Behandlungsmethoden
        private void fileNew_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Neu");
        }
        private void fileOpen_Click(object sender, EventArgs e)
        {
            MessageBox.Show("ffnen");
        }
        private void fileSave_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Speichern");
        }
        private void fileQuit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

    }
    
    

}