using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;


namespace Split_List_Tree
{
    public partial class Form1 : Form
    {
        private List<String[]> nations;
        private SplitContainer mySplitContainer = new SplitContainer();
        private TreeView myTreeView = new TreeView();
        private ListView myListView = new ListView();

        private ContextMenuStrip contextMenuStrip;
        
        private TreeNode mcNode = null;

        public Form1()
        {
            // Form1
            ClientSize = new Size(516,258);
            Text = "Explorer";

            nations = new List<String[]>();
            nations.Add(new String[5] {"Deutschland", "Europa", "Berlin", "3.460.000", "Hauptstadt"});
            nations.Add(new String[5] {"Deutschland", "Europa", "Frankfurt", "652.000", "Hauptstadt"});
            nations.Add(new String[5] {"Deutschland", "Europa", "Dresden", "474.000", ""});
            nations.Add(new String[5] {"Frankreich", "Europa", "Paris", "9.320.000", "Hauptstadt"});
            nations.Add(new String[5] {"Frankreich", "Europa", "Lyon", "422.000", ""});
            nations.Add(new String[5] {"Frankreich", "Europa", "Dijon", "151.000", ""});
            nations.Add(new String[5] {"Norwegen", "Europa", "Oslo", "477.000", "Hauptstadt"});
            nations.Add(new String[5] {"Norwegen", "Europa", "Bergen", "219.000", ""});
            nations.Add(new String[5] {"Kanada", "Amerika", "Ottawa", "980.000", "Hauptstadt"});
            nations.Add(new String[5] {"Kanada", "Amerika", "Toronto", "4.100.000", ""});
            nations.Add(new String[5] {"Kanada", "Amerika", "Vancouver", "1.700.000", ""});
            nations.Add(new String[5] {"Peru", "Amerika", "Lima", "5.759.000", "Hauptstadt"});
            nations.Add(new String[5] {"Japan", "Asien", "Tokio", "11.810.000", "Hauptstadt"}); 


            // mySplitContainer
            mySplitContainer.Dock = DockStyle.Fill;
            mySplitContainer.Panel1.Controls.Add(this.myTreeView);
            mySplitContainer.Panel2.Controls.Add(this.myListView);
            mySplitContainer.Size = new Size(516,258);
            mySplitContainer.SplitterDistance = 172;
            Controls.Add(this.mySplitContainer);


            // myTreeView
            myTreeView.Dock = DockStyle.Fill;
            myTreeView.ImageList = new ImageList();
            myTreeView.ImageList.Images.Add(Bitmap.FromFile("..\\..\\TreeLevel1.bmp"));
            myTreeView.ImageList.Images.Add(Bitmap.FromFile("..\\..\\TreeLevel1_selected.bmp"));
            myTreeView.ImageList.Images.Add(Bitmap.FromFile("..\\..\\TreeLevel2.bmp"));
            myTreeView.ImageList.Images.Add(Bitmap.FromFile("..\\..\\TreeLevel2_selected.bmp"));
            
            myTreeView.AfterSelect += myTreeView_AfterSelect;
            myTreeView.NodeMouseClick += myTreeView_NodeMouseClick; 

            // Strings mit Kontinent- und Lndernamen als Knoten erster bzw. zweiter Ordnung 
            // in Strukturansicht einfgen
            foreach (String[] nation in nations)
            {
                // Sofern der Kontinent (nation[1]) noch nicht in der obersten 
                // TreeNodeCollection (myTreeView.Nodes) zu finden ist, trage ihn nun ein
                if (!myTreeView.Nodes.ContainsKey(nation[1]))
                {
                    // Den Kontinentnamen (nation[1]) als Schlssel (Key) und Text bergeben
                    myTreeView.Nodes.Add(nation[1],nation[1], 0, 1);
                }

                // Sofern das Land (nation[0]) noch nicht in der untergeordneten 
                // TreeNodeCollection fr den Kontinent (myTreeView.Nodes[index].Nodes) 
                // zu finden ist, trage es nun ein
                int contIndex = myTreeView.Nodes.IndexOfKey(nation[1]);
                if (!myTreeView.Nodes[contIndex].Nodes.ContainsKey(nation[0]))
                {
                    // Den Kontinentnamen (nation[0]) als Schlssel (Key) und Text bergeben
                    myTreeView.Nodes[contIndex].Nodes.Add(nation[0],nation[0], 2, 3);
                }
            }
            
            // myListView
            myListView.Dock = DockStyle.Fill;
            myListView.View = View.Details;
            myListView.ColumnClick += new ColumnClickEventHandler(myListView_ColumnClick);

            myListView.Columns.Add("Stadt", 100, HorizontalAlignment.Left);
            myListView.Columns.Add("Einw.", 75, HorizontalAlignment.Right);
            myListView.Columns.Add("Bemerkungen", 150, HorizontalAlignment.Right);

            myListView.SmallImageList = new ImageList();
            myListView.LargeImageList = new ImageList();
            myListView.LargeImageList.ImageSize = new Size(50, 50);
            
            myListView.SmallImageList.Images.Add(Bitmap.FromFile("..\\..\\City.bmp"));
            myListView.SmallImageList.Images.Add(Bitmap.FromFile("..\\..\\Capital.bmp"));
            myListView.LargeImageList.Images.Add(Bitmap.FromFile("..\\..\\City.bmp"));
            myListView.LargeImageList.Images.Add(Bitmap.FromFile("..\\..\\Capital.bmp"));




            // Kontextmens
            contextMenuStrip = new ContextMenuStrip();
            contextMenuStrip.Items.AddRange(new ToolStripItem[] {
                    new ToolStripMenuItem("Kleine Symbole", null, this.command_Click), 
                    new ToolStripMenuItem("Groe Symbole", null, this.command_Click), 
                    new ToolStripMenuItem("Kacheln", null, this.command_Click), 
                    new ToolStripMenuItem("Liste", null, this.command_Click), 
                    new ToolStripMenuItem("Details", null, this.command_Click), 
                    });
            myListView.ContextMenuStrip = contextMenuStrip;



            ContextMenuStrip treeVContextMenu = new ContextMenuStrip();
            ToolStripMenuItem treeVCommand1 = new ToolStripMenuItem();
            treeVCommand1.Text = "Knoten expandieren";
            treeVCommand1.Click += new EventHandler(this.treeVCommand1_Click);
            treeVContextMenu.Items.Add(treeVCommand1);
            
            // Das Kontextmen an die Knoten der ersten Ebene zuweisen
            foreach (TreeNode n in myTreeView.Nodes)
                n.ContextMenuStrip = treeVContextMenu;
        }

        private void myListView_ColumnClick(Object sender, ColumnClickEventArgs e)
        {
            if (myListView.Sorting == SortOrder.Ascending)
                myListView.Sorting = SortOrder.Descending;
            else
                myListView.Sorting = SortOrder.Ascending;
        }

        private void myTreeView_NodeMouseClick(Object sender,
                                               TreeNodeMouseClickEventArgs e)
        {
            mcNode = e.Node;
        }




        private void myTreeView_AfterSelect(Object sender,
                                            TreeViewEventArgs e)
        {
            // Stdte zu ausgewhltem Land in Liste laden.
            myListView.Items.Clear();

            foreach (String[] nation in nations)
            {
                ListViewItem item;
                
                // Listenelemente fr das Land aus der Strukturansicht erzeugen 
                if (nation[0] == e.Node.Text)
                {
                    if (nation[4] == "Hauptstadt")
                        item = new ListViewItem(nation[2],1);
                    else
                        item = new ListViewItem(nation[2],0);

                    // Unterelemente fr Spalten
                    item.SubItems.Add(nation[3]);
                    item.SubItems.Add(nation[4]);
                    
                    // Referenz auf Originaldaten
                    item.Tag = nation;
                    
                    myListView.Items.Add(item);
                }
            }
        }

        private void command_Click(object sender,EventArgs e)
        {
            if (sender is ToolStripMenuItem)
            {
                ToolStripMenuItem mi = (ToolStripMenuItem) sender;
                if (mi.Text == "Kleine Symbole")
                    myListView.View = View.SmallIcon;
                else if (mi.Text == "Groe Symbole")
                    myListView.View = View.LargeIcon;
                else if (mi.Text == "Kacheln")
                {
                    myListView.CheckBoxes = false;
                    myListView.TileSize = new Size(myListView.ClientSize.Width/2, 50);
                    myListView.View = View.Tile;
                }
                else if (mi.Text == "Liste")
                    myListView.View = View.List;
                else if (mi.Text == "Details")
                    myListView.View = View.Details;
            }
        }
    
        private void treeVCommand1_Click(object sender, EventArgs e)
        {
            if (mcNode != null)
            {
                mcNode.ExpandAll();
                myTreeView.SelectedNode = mcNode;
            }
        }

    }
}