using System;
using System.Windows.Forms;
using System.Drawing;

namespace ExtendedControls
{
    public class MagnifyingLabel : Label
    {
        private Font oldFont;
        private int amount;          // Punkte, um die die Schrift vergrert wird

        public MagnifyingLabel()
        {
            amount = 1;
        }

        // Zustzliche Eigenschaft
        public int Amount
        {
            get
            {
                return amount;
            }
            set
            {
                amount = value;
            }
        }

        // Schrift vergrern
        protected override void OnMouseHover(EventArgs e)
        {
            oldFont = this.Font;
            Font newFont = new Font(oldFont.Name,
                                    oldFont.SizeInPoints + amount,
                                    oldFont.Style);
            this.Font = newFont;

            base.OnMouseHover(e);
        }

        // Schrift zurcksetzen
        protected override void OnMouseLeave(EventArgs e)
        {
            this.Font = oldFont;
            base.OnMouseLeave(e);
        }
        
    }
}

