using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DragAndDrop
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
            // Drag&Drop-Quelle mit Daten fllen
            dragSource.Items.AddRange(new string[] {"Spinnen", "Medusa", "Teufel",
                                                    "Schnecken", "Golem", "Skylla", "Charybdis"});
                                                
            // Drag&Drop-Ziel aktivieren  
            dropTarget.AllowDrop = true;
        }


        /*
         * Drag-Daten aufnehmen
         */
        private void dragSource_MouseDown(object sender, MouseEventArgs e)
        {
            string item;
            int index = dragSource.SelectedIndex;
            
            if (index >= 0)
            {
                item = (String) dragSource.Items[index]; 
            
                DragDropEffects result = dragSource.DoDragDrop(item, DragDropEffects.Move);
                
                if (result == DragDropEffects.Move)
                {
                    dragSource.Items.RemoveAt(index);
                }    
                else if (result == DragDropEffects.None)
                {
                    MessageBox.Show("Verschieben Sie die ausgewhlten Objekte in das "
                                    + "zweite Listenfeld",
                                    "Falsches Drop-Ziel");
                }   
            } 
        }

        /*
         * kein Drag aus der Anwendung heraus
         */
        private void dragSource_QueryContinueDrag(object sender, QueryContinueDragEventArgs e)
        {
            Form f = dragSource.FindForm();
            Point offset = SystemInformation.WorkingArea.Location;

            if (((Control.MousePosition.X - offset.X) < f.DesktopBounds.Left) ||
                ((Control.MousePosition.X - offset.X) > f.DesktopBounds.Right) ||
                ((Control.MousePosition.Y - offset.Y) < f.DesktopBounds.Top) ||
                ((Control.MousePosition.Y - offset.Y) > f.DesktopBounds.Bottom)) 
            {
                e.Action = DragAction.Cancel;
            }
        }


        /*
         * Drag-Daten prfen und Drop-Operation anzeigen
         */
        private void dropTarget_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Move;
            }
        }

        /*
         * Drag-Daten bernehmen
         */
        private void dropTarget_DragDrop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                dropTarget.Items.Add((String) e.Data.GetData(DataFormats.Text));
            }
        }
    }
}