using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Texteditor
{
    public partial class SearchDialog : Form
    {
        private Form1 form;
        private int pos;
        
        public SearchDialog(Form1 form)
        {
            InitializeComponent();
            this.form = form;
            this.Owner = form;
            pos = 0;
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            String search = this.tbSearchText.Text;
            
            if (string.IsNullOrEmpty(search))
                return;
            
            String text = form.textBox1.Text;
            int index = text.IndexOf(search, pos);
            
            if (index == -1)
            {
                MessageBox.Show("Text nicht gefunden", "Meldung");
                pos = 0;
            }
            else
            {
                form.textBox1.Focus();
                form.textBox1.Select(index, search.Length);
                pos = index + search.Length;
                form.textBox1.ScrollToCaret();
            }                
                

        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void SearchDialog_FormClosing(object sender, FormClosingEventArgs e)
        {
            form.searchDlg = null;
        }
    }
}