using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Animation_v2
{    
    
    public partial class Form1 : Form
    {
        Image[] figure;
        Image   plant;
        Point pos;
        int nextImg;
        
        public Form1()
        {
            InitializeComponent();
            DoubleBuffered = true;
            
            figure = new Image[16];
            figure[0] = Animation_v2.Properties.Resources.Figur_01;
            figure[1] = Animation_v2.Properties.Resources.Figur_02;
            figure[2] = Animation_v2.Properties.Resources.Figur_03;
            figure[3] = Animation_v2.Properties.Resources.Figur_04;
            figure[4] = Animation_v2.Properties.Resources.Figur_05;
            figure[5] = Animation_v2.Properties.Resources.Figur_06;
            figure[6] = Animation_v2.Properties.Resources.Figur_07;
            figure[7] = Animation_v2.Properties.Resources.Figur_08;
            figure[8] = Animation_v2.Properties.Resources.Figur_09;
            figure[9] = Animation_v2.Properties.Resources.Figur_10;
            figure[10] = Animation_v2.Properties.Resources.Figur_11;
            figure[11] = Animation_v2.Properties.Resources.Figur_12;
            figure[12] = Animation_v2.Properties.Resources.Figur_13;
            figure[13] = Animation_v2.Properties.Resources.Figur_14;
            figure[14] = Animation_v2.Properties.Resources.Figur_15;
            figure[15] = Animation_v2.Properties.Resources.Figur_16;
            
            nextImg = 0;
            pos = new Point(50, 50);
            
            plant = Animation_v2.Properties.Resources.Pflanze;

            // Timer erzeugen, konfigurieren und starten
            timer1 = new Timer();
            timer1.Interval = 100;
            timer1.Tick += new System.EventHandler(this.timer1_Tick);
            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            nextImg = ++nextImg % figure.Length;
            
            // Figur vorrcken oder an Anfang zurcksetzen
            pos.X = (pos.X + 10);
            if (pos.X > this.Width + figure[0].Width)
                pos.X = -figure[0].Width;
                
            this.Invalidate();
        }



        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            // Skalierung, die unterschiedliche Auflsungen ausgleicht
            double scaleFX = g.DpiX/figure[0].HorizontalResolution;
            double scaleFY = g.DpiY/figure[0].VerticalResolution;
            int imgWidth = (int) (figure[0].Width * scaleFX);
            int imgHeight = (int) (figure[0].Height * scaleFY);
            
            // Hintergrund
            g.Clear(Color.FromArgb(183, 233, 245));
            // Boden
            g.FillRectangle(Brushes.Lime, new Rectangle(0, pos.Y+imgHeight, this.Width, 7));
            // Pflanzen im Hintergrund
            g.DrawImage(plant, 120, pos.Y + imgHeight - (int) (plant.Height*scaleFY));
            g.DrawImage(plant, 440, pos.Y + imgHeight - 50 - (int) (plant.Height*scaleFY));            
            // Figur
            g.DrawImage(figure[nextImg], pos.X, pos.Y);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (this.DoubleBuffered == false)
            {
                this.DoubleBuffered = true;
                button1.Text = "Buffering ausschalten";
            }
            else
            {
                this.DoubleBuffered = false;
                button1.Text = "Buffering einschalten";
            }
        }
    }
}