using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Animation_v3
{    
    
    public partial class Form1 : Form
    {
        Image[] figure;
        Image   plant;
        Point pos;
        int nextImg;
        bool bufferedVersion;
        
        public Form1()
        {
            InitializeComponent();
            DoubleBuffered = true;
            
            figure = new Image[16];
            figure[0] = Animation_v3.Properties.Resources.Figur_01;
            figure[1] = Animation_v3.Properties.Resources.Figur_02;
            figure[2] = Animation_v3.Properties.Resources.Figur_03;
            figure[3] = Animation_v3.Properties.Resources.Figur_04;
            figure[4] = Animation_v3.Properties.Resources.Figur_05;
            figure[5] = Animation_v3.Properties.Resources.Figur_06;
            figure[6] = Animation_v3.Properties.Resources.Figur_07;
            figure[7] = Animation_v3.Properties.Resources.Figur_08;
            figure[8] = Animation_v3.Properties.Resources.Figur_09;
            figure[9] = Animation_v3.Properties.Resources.Figur_10;
            figure[10] = Animation_v3.Properties.Resources.Figur_11;
            figure[11] = Animation_v3.Properties.Resources.Figur_12;
            figure[12] = Animation_v3.Properties.Resources.Figur_13;
            figure[13] = Animation_v3.Properties.Resources.Figur_14;
            figure[14] = Animation_v3.Properties.Resources.Figur_15;
            figure[15] = Animation_v3.Properties.Resources.Figur_16;
            plant = Animation_v3.Properties.Resources.Pflanze;
           
            nextImg = 0;
            pos = new Point(50, 50);
            bufferedVersion = false;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            nextImg = ++nextImg % figure.Length;
            
            pos.X = (pos.X + 10);
            if (pos.X > this.Width + figure[0].Width)
                pos.X = -figure[0].Width;

            Graphics g = this.CreateGraphics();

            // Skalierung zur Anpassung der unterschiedl. Auflsungen
            double scaleF = g.DpiY/figure[0].VerticalResolution;
            int imgWidth = (int) (figure[0].Width * scaleF);
            int imgHeight = (int) (figure[0].Height * scaleF);
                
            // Auerhalb von Paint-Methode zeichnen
            if (bufferedVersion == false)
            {
                // Ungepuffertes Zeichnen erzeugt Flackern
      
                // Hintergrund
                g.FillRectangle(Brushes.Black, new Rectangle(0, 0, this.Width, this.Height/2));
                g.Clear(Color.FromArgb(183, 233, 245));
                g.FillRectangle(Brushes.Lime, new Rectangle(0, pos.Y+imgHeight, this.Width, 7));
                g.DrawImage(plant, 120, pos.Y+imgHeight - (int) (plant.Height*scaleF));
                g.DrawImage(plant, 440, pos.Y+imgHeight - 50 - (int) (plant.Height*scaleF));            
                
                // Figur
                g.DrawImage(figure[nextImg], pos.X, pos.Y);
            }
            else
            {
                // Double Buffering fr flackerfreies Zeichnen
                
                // Puffer-Gertekontext erzeugen
                BufferedGraphicsContext bgc = BufferedGraphicsManager.Current;
                BufferedGraphics bg = bgc.Allocate(g, this.ClientRectangle);
                
                // In Puffer zeichnen
                bg.Graphics.FillRectangle(Brushes.Black, new Rectangle(0, 0, this.Width, this.Height/2));
                bg.Graphics.Clear(Color.FromArgb(183, 233, 245));
                bg.Graphics.FillRectangle(Brushes.Lime, new Rectangle(0, pos.Y+imgHeight, this.Width, 7));
                bg.Graphics.DrawImage(plant, 120, pos.Y+imgHeight - (int) (plant.Height*scaleF));
                bg.Graphics.DrawImage(plant, 440, pos.Y+imgHeight - 50 - (int) (plant.Height*scaleF));            
                bg.Graphics.DrawImage(figure[nextImg], pos.X, pos.Y);
                   
                // Puffer in eigentliche Zeichenflche rendern
                bg.Render();
                bg.Dispose();
            } 
            
            g.Dispose();
        }



        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            
            double scaleF = g.DpiY/figure[0].VerticalResolution;
            int imgWidth = (int) (figure[0].Width * scaleF);
            int imgHeight = (int) (figure[0].Height * scaleF);
            
            g.Clear(Color.FromArgb(183, 233, 245));
            g.FillRectangle(Brushes.Lime, new Rectangle(0, pos.Y+imgHeight, this.Width, 7));
            g.DrawImage(plant, 120, pos.Y+imgHeight - (int) (plant.Height*scaleF));
            g.DrawImage(plant, 440, pos.Y+imgHeight - 50 - (int) (plant.Height*scaleF));       
            
            g.DrawImage(figure[nextImg], pos.X, pos.Y);                 
        }

        private void btn_startBuffered_Click(object sender, EventArgs e)
        {
            timer1.Start();
            bufferedVersion = true;
        }

        private void btn_startUnbuffered_Click(object sender, EventArgs e)
        {
            timer1.Start();
            bufferedVersion = false;
        }

        private void btn_stop_Click(object sender, EventArgs e)
        {
            timer1.Stop();
        }

        private void button0_Click(object sender, EventArgs e)
        {

        }

    }
}