using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;

namespace Clipping
{
    public partial class Form1 : Form
    {
        Image img;
        OpenFileDialog openFileDialog1;
        SaveFileDialog saveFileDialog1;
     
        Random gen;   
        
        public Form1()
        {
            InitializeComponent();
            ResizeRedraw = true;
            img = null;
 
            gen = new Random();
 
            openFileDialog1 = new OpenFileDialog();
            openFileDialog1.InitialDirectory = ".";
            openFileDialog1.Filter = "Windows Bitmap (*.bmp) | *.bmp"
                                   + "| JPEG (*.jpg) | *.jpg"
                                   + "| PNG (*.png) | *.png"
                                   + "| Windows Metafile (*.wmf) | *.wmf"
                                   + "| Grafikdatei (*.bmp;*.jpg;*.png;*.wmf) | *.bmp;*.jpg;*.png;*.wmf";
            openFileDialog1.FilterIndex = 5;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            
            saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.InitialDirectory = ".";
            saveFileDialog1.Filter = "Windows Bitmap (*.bmp) | *.bmp"
                                   + "| JPEG (*.jpg) | *.jpg"
                                   + "| PNG (*.png) | *.png";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.RestoreDirectory = true;
       }

        private void ffnenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                // Bild laden
                img = Image.FromFile(openFileDialog1.FileName);
                
                // Fenstergre an Bild anpassen
                this.ClientSize = new Size(img.Width, img.Height + menuStrip1.Height);
                
                // Rendering des Bildes anstoen
                this.Refresh();
            }
        }

        private void speichernToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (img == null)
                return;
                
            // voreingestellten Dateityp an Bildformat anpassen
            if (img.RawFormat.Equals(ImageFormat.Bmp))
                saveFileDialog1.FilterIndex = 1;    
            else if (img.RawFormat.Equals(ImageFormat.Jpeg))
                saveFileDialog1.FilterIndex = 2;
            else 
                saveFileDialog1.FilterIndex = 3;    
                
                
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                if (saveFileDialog1.FileName == openFileDialog1.FileName)
                {
                    MessageBox.Show("Zurckschreiben in die alte Datei wird nicht untersttzt");
                    return;
                }
               
                switch (saveFileDialog1.FilterIndex)
                {
                case 1 : img.Save(saveFileDialog1.FileName, ImageFormat.Bmp);    
                         break;
                case 2 : img.Save(saveFileDialog1.FileName, ImageFormat.Jpeg);    
                         break;
                case 3 : img.Save(saveFileDialog1.FileName, ImageFormat.Png);    
                         break;
                }         
            }            
        }

        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }


        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            if (img != null)
            {
                GraphicsPath gp = new GraphicsPath();
                gp.AddEllipse(new Rectangle(0, 0, panel1.ClientSize.Width, panel1.ClientSize.Height));
                
                e.Graphics.SetClip(gp);
                e.Graphics.SetClip(new Rectangle(30, 30, panel1.ClientSize.Width-60, panel1.ClientSize.Height-60), CombineMode.Intersect);

                e.Graphics.DrawImage(img, 0, 0, panel1.ClientSize.Width, panel1.ClientSize.Height);
            }
        }

    }
}