using System;
using System.Collections.Generic;
using System.Text;

namespace Fraktale
{
    public struct Complex
    {
        public double real;
        public double imag;

        public Complex(double real, double imag)  
        {
            this.real = real;
            this.imag = imag;
        }

        public double Abs()
        {
            return Math.Sqrt(real*real + imag*imag);
        }
                

        public static Complex operator +(Complex c1, Complex c2)
        {
            return new Complex(c1.real + c2.real, c1.imag + c2.imag);
        }

        public static Complex operator *(Complex c1, Complex c2)
        {
            double r, i;
            
            r = (c1.real * c2.real) - (c1.imag * c2.imag);
            i = (c1.real * c2.imag) + (c1.imag * c2.real);
            
            return new Complex(r, i);
        }


        public override string ToString()
        {
            return (String.Format("{0} + {1}i", real, imag));
        }

    }
}
