using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace Fraktale
{
    public partial class Form1 : Form
    {
        ThreadStart ts;
        Thread      thread;
        
        public Form1()
        {
            InitializeComponent();
            ts = new ThreadStart(this.calculateFractal);
        }

        private void calculateFractal()
        {
            Rectangle rect = this.ClientRectangle;
            Graphics g = this.CreateGraphics();
            SolidBrush brush = new SolidBrush(Color.White);
            
            g.Clear(Color.White);
            
            try
            {
                Complex c = new Complex(-0.012, 0.74);
                
                for (int i = rect.Left; i < rect.Right; ++i)
                    for (int j = rect.Top; j < rect.Bottom; ++j)
                    {
                        Complex x = new Complex(0.0001*i, 0.0001*j);
                        for (int n = 0; n < 100; ++n)
                        {
                            if (x.Abs() > 100)
                                break;
                                
                            x = x*x + c;
                        }
                    
                        if (x.Abs() < 1)
                            g.FillRectangle(Brushes.Blue, i, j, 1, 1);
                        else
                        {
                            brush.Color = Color.FromArgb((int) (x.Abs())%255, 255, 255);
                            g.FillRectangle(brush, i, j, 1, 1);
                        }
                    }
                    
            }
            catch (ThreadAbortException)
            {
            }
            finally
            {
                brush.Dispose();
                g.Dispose();
            }
        }
        
        private void button1_Click(object sender, EventArgs e)
        {
            if (thread != null)
            {
                thread.Abort();
                thread = null;
            }
                
            thread = new Thread(ts);
            thread.IsBackground = true;
            thread.Start();
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            if (thread != null)
            {
                thread.Abort();
                thread = null;
            }
                
            thread = new Thread(ts);
            thread.IsBackground = true;
            thread.Start();
        }
    }
}