using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Freihandlinien
{
    public partial class Form1 : Form
    {
        // Die Point-Auflistung zum Speichern der eingezeichneten Punkte
        private List<Point> points;
        
        public Form1()
        {
            points = new List<Point>(50);
            InitializeComponent();
        }
        
        private void panel1_MouseMove(object sender, MouseEventArgs e)
        {
            // nur Zeichnen wenn die linke Maustaste gedrckt wird
            if (e.Button == MouseButtons.Left)
            {
                // Punkt an aktueller Position zeichnen
                Graphics gc = panel1.CreateGraphics();
                gc.DrawRectangle(Pens.Black, e.X, e.Y, 1, 1);
                gc.Dispose();
                
                // Punktkoordinaten fr Rekonstruktion in Paint speichern
                points.Add(new Point(e.X, e.Y));
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Zeichenflche lschen und Point-Auflistung leeren
            Graphics gc = panel1.CreateGraphics();
            gc.Clear(SystemColors.Control);
            gc.Dispose();
            
            points.Clear();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            // Zeichnung rekonstruieren
            Graphics g = e.Graphics;
            g.Clear(SystemColors.Control);
            
            if (points.Count > 0)
            {
                foreach (Point p in points)
                    g.DrawRectangle(Pens.Blue, p.X, p.Y, 1, 1);
            }
        }
        
    }
}