using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;

namespace Metadateien
{
    public partial class Form1 : Form
    {
        private Metafile metafile;
        
        public Form1()
        {
            InitializeComponent();
            metafile = null;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Metadatei erzeugen
            Graphics gc = Graphics.FromImage(new Bitmap(50, 50));
            IntPtr hdc = gc.GetHdc();

            metafile = new Metafile("emblem.emf", hdc, EmfType.EmfOnly);

            gc.ReleaseHdc(hdc);       
            gc.Dispose();
                 
                 
            // In Metadatei zeichnen
            Graphics mgc = Graphics.FromImage(metafile);
            mgc.SmoothingMode = SmoothingMode.AntiAlias;

            mgc.FillRectangle(Brushes.Ivory, 0, 0, 50, 50 );
            mgc.DrawRectangle(Pens.Black, 0, 0, 50, 50 );
            mgc.FillEllipse(Brushes.Thistle, 2, 15, 46, 20 );
            mgc.FillEllipse(Brushes.Thistle, 15, 2, 20, 46 );
            
            mgc.Dispose();
            
            // Metadatei als PNG speichern
            metafile.Save("emblem.png", ImageFormat.Png);
        }
        
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (metafile != null)
                e.Graphics.DrawImage(metafile, new Point(10,10));
        }

    }
}