using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

namespace Transformationen
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ResizeRedraw = true;
        }

        private void tabPage1_Paint(object sender, PaintEventArgs e)
        {
            // Verschieben
            Graphics g = e.Graphics;

            g.FillRectangle(Brushes.LightBlue, tabPage1.ClientSize.Width/2  -10,
                                               tabPage1.ClientSize.Height/2 -10,
                                               20, 20); 
                          
            // Ursprung in den Mittelpunkt des Formulars verschieben
            g.TranslateTransform(tabPage1.ClientSize.Width/2, tabPage1.ClientSize.Height/2);

            g.FillRectangle(Brushes.Blue, -10, -10, 20, 20);
        }

        private void tabPage2_Paint(object sender, PaintEventArgs e)
        {
            // Drehen
            Graphics g = e.Graphics;
            
            g.TranslateTransform(tabPage2.ClientSize.Width/2, tabPage2.ClientSize.Height/2);
            
            // Koordinatenachsen zeichnen
            Pen kosPen = new Pen(Brushes.Black, 5);
            kosPen.StartCap = LineCap.ArrowAnchor;
            kosPen.EndCap = kosPen.StartCap;
            
            g.DrawLine(kosPen, new Point(-(tabPage2.ClientSize.Width/2 - 10), 0),
                               new Point(+(tabPage2.ClientSize.Width/2 - 10), 0));
            g.DrawLine(kosPen, new Point(0, -(tabPage2.ClientSize.Height/2 - 10)),
                               new Point(0, +(tabPage2.ClientSize.Height/2 - 10)));

            g.FillRectangle(Brushes.LightBlue, -10, -10, 20, 20); 
            g.FillRectangle(Brushes.LightBlue, 50, -10, 50, 20); 
                                          
            g.RotateTransform(45.0F);
            
            g.FillRectangle(Brushes.Blue, -10, -10, 20, 20); 
            g.FillRectangle(Brushes.Blue, 50,-10, 50, 20); 

            g.Dispose();
        }

        private void tabPage3_Paint(object sender, PaintEventArgs e)
        {
            // Skalieren
            Graphics g = e.Graphics;

            g.DrawRectangle(Pens.Black, 20, 10, 70, 33);
            g.DrawString("Hallo", new Font("Arial", 20), Brushes.Black, 20, 12);

            g.ScaleTransform(5.0F, 1.0F);

            g.DrawRectangle(Pens.Black, 20, 10, 70, 33);
            g.DrawString("Hallo", new Font("Arial", 20), Brushes.Black, 20, 12);

            g.Dispose();
        }

        private void tabPage4_Paint(object sender, PaintEventArgs e)
        {
            // Kombinieren
            Graphics g = e.Graphics;
            
            g.TranslateTransform(tabPage4.ClientSize.Width/2, tabPage4.ClientSize.Height/2);
            g.ScaleTransform(2.0F, -2.0F);
            
            g.FillEllipse(Brushes.Blue, -5, -5, 10, 10);
            g.DrawLine(Pens.Black, new Point(0,0), new Point(10,10));
            
            g.Dispose();
        }
        
        
        
    }
}