using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Zeichenmethoden
{
    public partial class Form1 : Form
    {
        
        public Form1()
        {
            InitializeComponent();
            
            tabControl1.SelectedIndex = 0;
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
        }

        private void tab_VertText_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            
            // Textabmae bestimmen
            g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.ClearTypeGridFit;
            StringFormat sf = StringFormat.GenericTypographic;
            sf.FormatFlags = StringFormatFlags.DirectionVertical;
            
            // Rechts ungedreht zeichnen, aber mit demselben StringFormat-Objekt
            g.DrawString("Rechter Rand", Font, Brushes.Black, tab_VertText.ClientSize.Width - 20F, 10, sf);
            
            
            String s = "Linker Rand";
            SizeF size = g.MeasureString(s, Font, -1, sf );
            
            
            // Transformationsmatrix speichern
            System.Drawing.Drawing2D.Matrix tm = g.Transform;
            
            // Text gedreht zeichnen
            float xpos = 10F;
            float ypos = 10F;            
            g.TranslateTransform( xpos + size.Width/2, ypos + size.Height/2 );
            g.RotateTransform(180);  
            g.DrawString(s, Font, Brushes.Black, 0 - size.Width/2, 0 - size.Height/2, sf);
            
            // Transformationsmatrix wiederherstellen
            g.Transform = tm;
            // GenericTypographic-Format wiederherstellen
            sf.FormatFlags ^= StringFormatFlags.DirectionVertical;

        }

        private void tab_RtoL_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            
            String poem1 = 
                " Zu Dionys, dem Tyrannen, schlich\n" +
                " Damos, den Dolch im Gewande;\n" +
                " Ihn schlugen die Hscher in Bande.\n" +
                " \"Was wolltest du mit dem Dolche, sprich!\"\n" +
                " Entgegnet ihm der Wterich.-\n" +
                " \"Die Stadt vom Tyrannen befreien!\"-\n" +
                " \"Das sollst du am Kreuze bereuen.\"\n";
            String poem2 = 
                " Zu Dionys, dem Tyrannen, schlich\n" +
                " ;Damos, den Dolch im Gewande\n" +
                " ... ";
                                
            Point p1 = new Point(tab_RtoL.ClientSize.Width/2, 10);
            Point p2 = new Point(tab_RtoL.ClientSize.Width/2, tab_RtoL.ClientSize.Height - 10);
            g.DrawLine(Pens.Blue, p1, p2);   
            g.DrawString(poem1, Font, Brushes.Black, p1);
            g.DrawString(poem2, Font, Brushes.Black, p1, new StringFormat(StringFormatFlags.DirectionRightToLeft));
        }

        private void tab_Lines_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            
            g.FillEllipse(Brushes.Black, tab_Lines.ClientSize.Width/2 -2, tab_Lines.ClientSize.Height/2 -2, 4, 4);
        }

        private void tab_Lines_MouseMove(object sender, MouseEventArgs e)
        {
            Graphics g = tab_Lines.CreateGraphics();
            
            g.DrawLine(Pens.Black, tab_Lines.ClientSize.Width/2, tab_Lines.ClientSize.Height/2, e.X, e.Y);
            
            g.Dispose();
        }

        private void tab_Rects_Paint(object sender, PaintEventArgs e)
        {
            // schmales, waagerechtes Rechteck
            e.Graphics.DrawRectangle(Pens.Black, 10, 10, 200, 20);
            
            // ausgefllte rechteckige Flche
            e.Graphics.FillRectangle(Brushes.Red, 10, 40, 200, 20);
            
            // ausgeflltes Recheck
            e.Graphics.FillRectangle(Brushes.Red, 10, 70, 200, 20);
            e.Graphics.DrawRectangle(Pens.Black, 10, 70, 200, 20);
                                 
            // 1-Pixel-Punkt an der Position x,y zeichnen   
            int x = 350;
            int y = 110;             
            e.Graphics.FillRectangle(Brushes.Black, new Rectangle(x,y,1,1));
            
            // Rechteck-Gruppe zeichnen
            Rectangle[] rects = new Rectangle[] {
                                        new Rectangle(250,  10, 200,  20),
                                        new Rectangle(430,  10,  20, 200),
                                        new Rectangle(250, 190, 200,  20),
                                        new Rectangle(250,  10,  20, 200)
                                        };
            e.Graphics.DrawRectangles(Pens.Black, rects);                            
            
        }

        private void tab_Polygons_Paint(object sender, PaintEventArgs e)
        {
            Point[] points = new Point[] {
                                        new Point(100-40, 100),
                                        new Point(100, 10),
                                        new Point(100+40, 100),
                                       };
                                        
            e.Graphics.DrawPolygon(Pens.Red, points);
            e.Graphics.DrawLines(Pens.Blue, points);
            
            // Ausgefllte Polygonflchen
            Point[] hourglass = new Point[] {
                                        new Point(300-40, 100),
                                        new Point(300+40, 10),
                                        new Point(300-40, 10),
                                        new Point(300+40, 100),
                                       };
            e.Graphics.FillPolygon(Brushes.Red, hourglass);
           
        }

        private void tab_Ellipses_Paint(object sender, PaintEventArgs e)
        {
            // ausgefllte Ellipse
            e.Graphics.FillEllipse(Brushes.Red, 10, 10, 200, 100);
            e.Graphics.DrawEllipse(Pens.Black, 10, 10, 200, 100);
                                 
            // ausgefllter Kreis
            e.Graphics.FillEllipse(Brushes.Red, 300, 10, 200, 200);
            e.Graphics.DrawEllipse(Pens.Black, 300, 10, 200, 200);
            
            using (Pen bluePen = new Pen(Color.Blue, 5))
            {        
                e.Graphics.DrawArc(bluePen, 300, 10, 200, 200, 0, -90);
            }
                                 
        }

        private void tab_Bezier_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen curvePen = new Pen(Color.Blue, 5);                                       
            Pen linePen = new Pen(Color.Black, 2);                                       
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            
            
            // Spline-Kurve
                        
            Point[] points = new Point[] {
                                        new Point(50, 100),
                                        new Point(50,  50),
                                        new Point(200, 50),
                                        new Point(150, 100)
                                       };
                                                                                                                    
            g.DrawCurve(curvePen, points, 0.3F);                           
            
            foreach (Point p in points)
            {
                g.FillEllipse(Brushes.White, p.X-5, p.Y-5, 10, 10);
                g.DrawEllipse(Pens.Red, p.X-5, p.Y-5, 10, 10);
            }
                                       
                                       
                                       
                                       
            // Bzierkurve aus 2 Segmenten
                                       
            Point[] pointsA = new Point[] {
                                        new Point(350, 100),
                                        new Point(350,  50),
                                        new Point(500, 50),
                                        new Point(450, 100)
                                       };
            Point[] pointsB = new Point[] {
                                        new Point(450, 100),
                                        new Point(400, 150),
                                        new Point(550, 150),
                                        new Point(550, 100)
                                       };
                                       
                                       
            g.DrawBezier(curvePen, pointsA[0], pointsA[1], pointsA[2], pointsA[3]);
            g.DrawBezier(curvePen, pointsB[0], pointsB[1], pointsB[2], pointsB[3]);
            
            for (int i = 0; i < pointsA.Length; ++i)
            {
                if (i == 0 || i == 3)
                {
                    // Punkt, durch den die Kurve geht
                    g.FillEllipse(Brushes.White, pointsA[i].X-5, pointsA[i].Y-5, 10, 10);
                    g.DrawEllipse(Pens.Red, pointsA[i].X-5, pointsA[i].Y-5, 10, 10);
                }
                else
                    // Steuerpunkt
                    g.FillEllipse(Brushes.Black, pointsA[i].X-5, pointsA[i].Y-5, 10, 10);                
            }
            g.DrawLine(linePen, pointsA[0], pointsA[1]);
            g.DrawLine(linePen, pointsA[2], pointsA[3]);
            
            for (int i = 0; i < pointsA.Length; ++i)
            {
                if (i == 0 || i == 3)
                {
                    // Punkt, durch den die Kurve geht
                    g.FillEllipse(Brushes.White, pointsB[i].X-5, pointsB[i].Y-5, 10, 10);
                    g.DrawEllipse(Pens.Red, pointsB[i].X-5, pointsB[i].Y-5, 10, 10);
                }
                else
                    // Steuerpunkt
                    g.FillEllipse(Brushes.Gray, pointsB[i].X-5, pointsB[i].Y-5, 10, 10);                
            }
            g.DrawLine(linePen, pointsB[0], pointsB[1]);
            g.DrawLine(linePen, pointsB[2], pointsB[3]);
            
            curvePen.Dispose();
            linePen.Dispose();
        }

        private void tab_Centered_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
                        
            using (Font font = new Font("Tahoma", 12))
            {
                String s = "\"A thing of beauty  is a joy forever.\" (Keats)";
                
                // Textabmae bestimmen
                g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                StringFormat sf = StringFormat.GenericTypographic;                
                SizeF size = g.MeasureString(s, font, -1, sf );
            
                // Text zeichnen
                g.DrawString(s, font, Brushes.Black, 
                         tab_Centered.ClientSize.Width/2 - size.Width/2, 
                         tab_Centered.ClientSize.Height/2 - size.Height/2, sf);
            }

        }

        

    }
}