using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Text;
using System.Drawing.Drawing2D;


namespace Zeichenwerkzeuge
{
    public partial class Form1 : Form
    {
        private Font font;
        private String text;
        
        private int[] hsStyles;
        private string[] hsNames;
        private HatchBrush hsBrush;
        
        public Form1()
        {
            InitializeComponent();
            
            tabControl1.SelectedIndex = 3;
            
            
            font = new Font("Times New Roman", 12);

            text = "\"Ein hbsches Gesichtchen " +
                   "ist den Menschen angenehmer als " +
                   "eine Wahrheit ins Gesicht.\"";
                   
            // Installierte Schriften in das Listenfeld laden
            InstalledFontCollection ifc = new InstalledFontCollection();
            FontFamily[] families = ifc.Families;
            
            foreach (FontFamily f in families)
            {
                listBox1.Items.Add(f.Name);
            }
            
            // Generische Fonts
            button1.Text = new FontFamily(GenericFontFamilies.Monospace).Name;
            button2.Text = new FontFamily(GenericFontFamilies.SansSerif).Name;
            button3.Text = new FontFamily(GenericFontFamilies.Serif).Name;
            
            // Systemfonts
            button4.Text = SystemFonts.CaptionFont.Name + " " + SystemFonts.CaptionFont.Size;
            button5.Text = SystemFonts.DefaultFont.Name + " " + SystemFonts.DefaultFont.Size;
            button6.Text = SystemFonts.DialogFont.Name + " " + SystemFonts.DialogFont.Size;
            button7.Text = SystemFonts.IconTitleFont.Name + " " + SystemFonts.IconTitleFont.Size;
            button8.Text = SystemFonts.MenuFont.Name + " " + SystemFonts.MenuFont.Size;
            button9.Text = SystemFonts.MessageBoxFont.Name + " " + SystemFonts.MessageBoxFont.Size;
            button10.Text = SystemFonts.SmallCaptionFont.Name + " " + SystemFonts.SmallCaptionFont.Size;
            button11.Text = SystemFonts.StatusFont.Name + " " + SystemFonts.StatusFont.Size;
            
            
            
            // Schraffuren laden
            hsStyles = (int[]) HatchStyle.GetValues(typeof(HatchStyle));
            hsNames = (string[]) HatchStyle.GetNames(typeof(HatchStyle));
            comboBox1.DataSource = hsNames;
            hsBrush = null;
            
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawString(text, font, SystemBrushes.WindowText, 
                                  new Rectangle(10, 10, panel1.ClientSize.Width-20, panel1.ClientSize.Height-10));
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listBox1.SelectedItem != null)
            {
                font.Dispose();
                font = new Font((string) listBox1.SelectedItem, 12);
                panel1.Refresh();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (sender == button1)
            {
                font.Dispose();
                font = new Font(new FontFamily(GenericFontFamilies.Monospace), 12);
            } 
            else if (sender == button2)
            {
                font.Dispose();
                font = new Font(new FontFamily(GenericFontFamilies.SansSerif), 12);
            } 
            else if (sender == button3)
            {
                font.Dispose();
                font = new Font(new FontFamily(GenericFontFamilies.Serif), 12);
            } 
            else if (sender == button4)
            {
                font = SystemFonts.CaptionFont;
            } 
            else if (sender == button5)
            {
                font = SystemFonts.DefaultFont;
            } 
            else if (sender == button6)
            {
                font = SystemFonts.DialogFont;
            } 
            else if (sender == button7)
            {
                font = SystemFonts.IconTitleFont;
            } 
            else if (sender == button8)
            {
                font = SystemFonts.MenuFont;
            } 
            else if (sender == button9)
            {
                font = SystemFonts.MessageBoxFont;
            } 
            else if (sender == button10)
            {
                font = SystemFonts.SmallCaptionFont;
            } 
            else if (sender == button11)
            {
                font = SystemFonts.StatusFont;
            } 
            
            panel1.Refresh();
        }

        private void groupBox1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            
            g.FillRectangle(SystemBrushes.ControlLight, new Rectangle(groupBox1.ClientSize.Width/2 - 50, 
                                                                      groupBox1.ClientSize.Height/2 - 50, 100, 100));
            g.DrawRectangle(Pens.Black, new Rectangle(groupBox1.ClientSize.Width/2 - 50, 
                                                      groupBox1.ClientSize.Height/2 - 50, 100, 100));
        }

        private void panel2_MouseMove(object sender, MouseEventArgs e)
        {
            Color c = Color.FromArgb(0, e.X % 255 , e.Y % 255);
            panel2.BackColor = c;
            panel2.Refresh();
        }

        private void panel3_Paint(object sender, PaintEventArgs e)
        {
            Color c = Color.White;
            Pen pen = new Pen(c); 
            
            for (int i = 0; i <= 255; ++i)
            {
                pen.Color = Color.FromArgb(i, 255, 0, 0);
                e.Graphics.DrawLine(pen, 0, i, panel3.ClientSize.Width, i); 
            }
        }

        private void tab_Pens_Paint(object sender, PaintEventArgs e)
        {
            Pen pen1 = new Pen(Color.Black, 4);
            Pen pen2 = new Pen(Color.FromArgb((int) (DateTime.Now.Ticks % 255), 
                                              (int) (DateTime.Now.Ticks % 255), 
                                              (int) (DateTime.Now.Ticks % 255)), 2);

            e.Graphics.DrawLine(pen1, 10, 10, tab_Pens.ClientSize.Width-20, 10);
            e.Graphics.DrawLine(pen2, 10, 15, tab_Pens.ClientSize.Width-20, 15);
                                       
            pen1.Dispose();
            pen2.Dispose();
            
            
            e.Graphics.SmoothingMode = SmoothingMode.HighQuality;
            
            // Linien-Enden
            
            Pen lcPen = new Pen(Color.Black, 5);
            int[] lcStyles = (int[]) LineCap.GetValues(typeof(LineCap));
            string[] lcNames = (string[]) LineCap.GetNames(typeof(LineCap));
            
            for (int i = 1; i < lcStyles.Length-2; ++i)
            {
                lcPen.StartCap = (LineCap) lcStyles[i];
                lcPen.EndCap   = lcPen.StartCap;
                
                e.Graphics.DrawLine(lcPen, label15.Location.X + label15.Width +20, label15.Location.Y + label15.Height/2 +(i-1)*20, 
                                           label15.Location.X + label15.Width +70, label15.Location.Y + label15.Height/2 +(i-1)*20);
                e.Graphics.DrawString(lcNames[i], this.Font, Brushes.Black,
                                      label15.Location.X + label15.Width +100, label15.Location.Y +(i-1)*20);
            }
            lcPen.Dispose();
 
            
            // Linientypen
            
            Pen dsPen = new Pen(Color.Black, 5);
            int[] dStyles = (int[]) DashStyle.GetValues(typeof(DashStyle));
            string[] dNames = (string[]) DashStyle.GetNames(typeof(DashStyle));
            
            for (int i = 0; i < dStyles.Length-1; ++i)
            {
                dsPen.DashStyle = (DashStyle) dStyles[i];
                
                e.Graphics.DrawLine(dsPen, label16.Location.X + label16.Width +20, label16.Location.Y + label16.Height/2 +i*20, 
                                           label16.Location.X + label16.Width +70, label16.Location.Y + label16.Height/2 +i*20);
                e.Graphics.DrawString(dNames[i], this.Font, Brushes.Black,
                                      label16.Location.X + label16.Width +100, label16.Location.Y +i*20);
            }
            dsPen.Dispose();
 
            
            // Verbindungspunkte
            
            Pen ljPen = new Pen(Color.Black, 15);
            int[] ljStyles = (int[]) LineJoin.GetValues(typeof(LineJoin));
            string[] ljNames = (string[]) LineJoin.GetNames(typeof(LineJoin));
            
            for (int i = 0; i < ljStyles.Length; ++i)
            {
                ljPen.LineJoin = (LineJoin) ljStyles[i];
                
                Point[] points = new Point[] {
                                             new Point(label17.Location.X + label17.Width +20, label17.Location.Y + label17.Height/2 +i*50),
                                             new Point(label17.Location.X + label17.Width +70, label17.Location.Y + label17.Height/2 +i*50),
                                             new Point(label17.Location.X + label17.Width +20, label17.Location.Y + label17.Height/2 +i*50 + 30)
                                             };
                e.Graphics.DrawLines(ljPen, points);
            }

            ljPen.MiterLimit = 2.0F;
            
            for (int i = 0; i < ljStyles.Length; ++i)
            {
            
                Point[]  points = new Point[] {
                                             new Point(label17.Location.X + label17.Width +120, label17.Location.Y + label17.Height/2 +i*50),
                                             new Point(label17.Location.X + label17.Width +170, label17.Location.Y + label17.Height/2 +i*50),
                                             new Point(label17.Location.X + label17.Width +120, label17.Location.Y + label17.Height/2 +i*50 + 30)
                                             };
                e.Graphics.DrawLines(ljPen, points);

                e.Graphics.DrawString(ljNames[i], this.Font, Brushes.Black,
                                      label17.Location.X + label17.Width +200, label17.Location.Y +i*50);
                                      
            }
            ljPen.Dispose();


            Pen pen3 = new Pen(Color.Black, 5);
            pen3.StartCap = LineCap.RoundAnchor;
            pen3.EndCap   = LineCap.ArrowAnchor;
            pen3.DashStyle = DashStyle.Custom;
            pen3.DashPattern = new float[] {1.5F, 0.5F};
            
            e.Graphics.DrawLine(pen3, 10, tab_Pens.ClientSize.Height -30, 
                                      tab_Pens.ClientSize.Width-20, tab_Pens.ClientSize.Height -30);
                                       
            pen3.Dispose();            
        }


        private void tbl_panel1_Paint(object sender, PaintEventArgs e)
        {
            Brush brush1 = new SolidBrush(Color.Black);
            Brush brush2 = new SolidBrush(Color.FromArgb((int) (DateTime.Now.Ticks % 255), 
                                                         (int) (DateTime.Now.Ticks % 255), 
                                                         (int) (DateTime.Now.Ticks % 255)));

            e.Graphics.FillRectangle(brush1, 10, 20, tbl_panel1.ClientSize.Width-20, 5);
            e.Graphics.FillRectangle(brush2, 10, 25, tbl_panel1.ClientSize.Width-20, 15);
                                       
            brush1.Dispose();
            brush2.Dispose();
            
        }

        private void tbl_panel1_sub_MouseMove(object sender, MouseEventArgs e)
        {
            BufferedGraphicsContext bgc;
            BufferedGraphics bg;
            
            bgc = BufferedGraphicsManager.Current;
            
            bg = bgc.Allocate(tbl_panel1_sub.CreateGraphics(), tbl_panel1_sub.ClientRectangle);
            bg.Graphics.Clear(Color.White);
            bg.Graphics.FillEllipse(Brushes.CornflowerBlue, 30, 30, tbl_panel1_sub.ClientRectangle.Width-60, tbl_panel1_sub.ClientRectangle.Height-60); 
            
            int trans = 255 * e.X / tbl_panel1_sub.ClientSize.Width;
            int blue =  255 * e.Y / tbl_panel1_sub.ClientSize.Height;
            SolidBrush brush = new SolidBrush(Color.FromArgb(trans, 255, 0, blue));
            bg.Graphics.FillRectangle(brush, 0, 0, tbl_panel1_sub.ClientRectangle.Width, tbl_panel1_sub.ClientRectangle.Height);
            
            bg.Render();
            
            bg.Dispose();
            brush.Dispose();
        }

        private void tbl_panel2_Paint(object sender, PaintEventArgs e)
        {
            Image img = Zeichenwerkzeuge.Properties.Resources.Granit;
            
            TextureBrush brush = new TextureBrush(img);
            
            e.Graphics.FillRectangle(brush, tbl_panel2.ClientRectangle);
            
            img.Dispose();
            brush.Dispose();
        }

        private void tbl_panel3_Paint(object sender, PaintEventArgs e)
        {
            if (hsBrush != null)           
                e.Graphics.FillRectangle(hsBrush, tbl_panel3.ClientRectangle);
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (hsBrush != null)  
                hsBrush.Dispose();
                         
            hsBrush = new HatchBrush( (HatchStyle) hsStyles[comboBox1.SelectedIndex], Color.Red);
            tbl_panel3.Refresh();
        }

        private void tbl_panel4_Paint(object sender, PaintEventArgs e)
        {
            LinearGradientBrush brush = new LinearGradientBrush(new Rectangle(0,0,
                                                                              tbl_panel4.ClientSize.Width, 10),
                                                                Color.White, Color.Red, 
                                                                LinearGradientMode.Horizontal);
                                                    
            e.Graphics.FillRectangle(brush, 0, 0, tbl_panel4.ClientRectangle.Width, tbl_panel4.ClientRectangle.Height/2);        
            
            brush = new LinearGradientBrush(new Rectangle(0,0,
                                                         tbl_panel4.ClientSize.Width, 10),
                                            Color.White, Color.Red, 
                                            LinearGradientMode.Vertical);
            e.Graphics.FillRectangle(brush, 0, tbl_panel4.ClientRectangle.Height/2, tbl_panel4.ClientRectangle.Width, tbl_panel4.ClientRectangle.Height);        
            
            
            brush.Dispose();                                                        
        }

        private void tbl_panel5_Paint(object sender, PaintEventArgs e)
        {
            Point[] triangle = new Point[] {  new Point(0, 0),
                                              new Point(0, 100),
                                              new Point(50, 50) };
                                              
            PathGradientBrush brush = new PathGradientBrush(triangle);
                                                    
            brush.WrapMode = WrapMode.TileFlipX;
            
            brush.CenterPoint = new Point(10, 50); 
            
            brush.CenterColor = Color.White;
            
            brush.SurroundColors = new Color[] {   Color.Red,
                                                   Color.Green,
                                                   Color.Blue    };
            
            e.Graphics.FillRectangle(brush, 0, 0, tbl_panel5.ClientRectangle.Width, tbl_panel5.ClientRectangle.Height);                                                                
            brush.Dispose();
        }





    }
}