using System;
using System.Collections.Generic;
using System.Text;

using System.IO;
using System.Diagnostics;

namespace MSPress.Entwicklerbuch
{
   //ber [Serializable] wird bei der Methode CreateInstanceAndUnwrap die
   //Methode in der AppDomain ausgefhrt, wo diese Instanziiert wurde.
   //Bei MarshalByRefObject wird die Methode im frienly-AppDomain ausgefhrt.
   [Serializable]
   public class FileHandler 
   {
      public FileHandler()
      {
         WriteToFile("ctor", @"adom.txt");

         //Daten aus anderer AppDomain
         string s = (string)AppDomain.CurrentDomain.GetData("keyOfData");
         WriteToFile(s, @"adom.txt");
      }

      public FileHandler(string text, string path)
      {
         WriteToFile("ctor:" + text, path);
      }

      public void WriteToFile(string text, string path)
      {
         FileStream fs = new FileStream(path, FileMode.Append);

         StreamWriter sw = new StreamWriter(fs);
         sw.WriteLine(text);
         sw.WriteLine(AppDomain.CurrentDomain.FriendlyName);
         sw.WriteLine("---------------------------------");
         sw.Flush();
         sw.Close();

         fs.Close();
      }
   }
}
