using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Security.Policy;     //Evidence
using System.Reflection;          //BindingFlags
using MSPress.Entwicklerbuch;
using System.Diagnostics;
using System.Security.Principal;  //PrincipalPolicy.WindowsPrincipal

namespace myAppDomain
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
         Debug.WriteLine(System.Threading.Thread.GetDomain().FriendlyName);
      }

      /// <summary>
      /// Erstellen einer Application-Domain.
      /// </summary>
      private void button1_Click(object sender, EventArgs e)
      {
         AppDomainSetup setup = new AppDomainSetup();

         setup.ApplicationBase = @"C:\VCS\";
         setup.PrivateBinPath = "bin;anyfolder";
         setup.ConfigurationFile = "ApplicationName.exe.config";

         Evidence evi = new Evidence();

         AppDomain domain = AppDomain.CreateDomain("friendlyName",evi,setup);
      }

      /// <summary>
      /// Ausfhren einer Assembly (Klassenbibliothek) in einer
      /// anderen Application-Domain (ohne Einstiegspunkt)
      /// </summary>
      private void button2_Click(object sender, EventArgs e)
      {
         AppDomainSetup setup = new AppDomainSetup();

         setup.ApplicationBase = "..\\..\\..\\FileHandler\\bin\\Debug";
         setup.PrivateBinPath = "bin;anyfolder";
         setup.ConfigurationFile = "ApplicationName.exe.config";

         AppDomain domain = AppDomain.CreateDomain("friendlyName", null, setup);

         //CreateInstance .. Assembly.Load -> ObjectHandle
         domain.CreateInstance("FileHandler", "MSPress.Entwicklerbuch.FileHandler");

         //Create Instance ber berladenen Konstruktor
         string p1_text = "Laden und Ausfhren";
         string p2_path = @"..\..\\adom.txt";
         object[] ctorArgs = { p1_text, p2_path };

         domain.CreateInstance("FileHandler", "MSPress.Entwicklerbuch.FileHandler",
                              true, BindingFlags.CreateInstance,
                              null, ctorArgs, null, null, null);
      }

      /// <summary>
      /// Ausfhren einer Assembly (Win oder Konsole) in einer
      /// anderen Application-Domain (mit Einstiegspunkt)
      /// </summary>
      private void button3_Click(object sender, EventArgs e)
      {
         AppDomainSetup setup = new AppDomainSetup();

         setup.ApplicationBase = "..\\..\\..\\DemoExecuteAssembly";
         setup.PrivateBinPath = "bin;anyfolder";
         setup.ConfigurationFile = "ApplicationName.exe.config";

         AppDomain domain = AppDomain.CreateDomain("friendlyName", null, setup);

         //ExecuteAssembly
         domain.ExecuteAssembly(@"..\\..\\..\\DemoExecuteAssembly\\bin\\Debug\\DemoExecuteAssembly.exe");
      }

      private void button4_Click(object sender, EventArgs e)
      {
         AppDomainSetup setup = new AppDomainSetup();

         setup.ApplicationBase = "..\\..\\..\\FileHandler\\bin\\Debug";
         setup.PrivateBinPath = "bin;anyfolder";
         setup.ConfigurationFile = "ApplicationName.exe.config";

         AppDomain domain = AppDomain.CreateDomain("friendlyName", null, setup);

         FileHandler fh = (FileHandler)domain.CreateInstanceAndUnwrap("FileHandler", typeof(FileHandler).FullName);

         fh.WriteToFile("Laden und Entladen", @"adom.txt");

         AppDomain.Unload(domain);
      }

      private void button5_Click(object sender, EventArgs e)
      {
         AppDomainSetup setup = new AppDomainSetup();

         setup.ApplicationBase = "..\\..\\..\\FileHandler\\bin\\Debug";
         setup.PrivateBinPath = "bin;anyfolder";
         setup.ConfigurationFile = "ApplicationName.exe.config";

         AppDomain domain = AppDomain.CreateDomain("friendlyName", null, setup);

         domain.SetData("keyOfData", "Data from Home-Domain");

         FileHandler fh = (FileHandler)domain.CreateInstanceAndUnwrap("FileHandler", typeof(FileHandler).FullName);

         fh.WriteToFile("Daten austauschen", @"adom.txt");

         AppDomain.Unload(domain);
      }
   }
}
