using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Xml;

namespace ProgrammingXML
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      private void button1_Click(object sender, EventArgs e)
      {
	     XmlDocument xml = new XmlDocument();
		 xml.Load(Application.StartupPath + "\\family.xml");
         xml.Save(Application.StartupPath + "\\temp.xml");
      }

      private void button2_Click(object sender, EventArgs e)
      {
         XmlDocument xml = new XmlDocument();
         xml.Load(Application.StartupPath + "\\family.xml");

         XmlNodeList nodeList = xml.GetElementsByTagName("member");

         foreach (XmlNode node in nodeList)
         {
            XmlElement xmlElement = xml.CreateElement("name2");
            xmlElement.InnerText = "empty";

            node.AppendChild(xmlElement);
         }

         xml.Save(Application.StartupPath + "\\temp.xml");
      }

      private void button3_Click(object sender, EventArgs e)
      {
         XmlDocument xml = new XmlDocument();
         xml.Load(Application.StartupPath + "\\family.xml");

         XmlNodeList nodeList = xml.GetElementsByTagName("name");

         foreach (XmlNode node in nodeList)
         {
            XmlAttribute xmlAttribute = xml.CreateAttribute("gender");
            xmlAttribute.Value = "not spec.";

            node.Attributes.Append(xmlAttribute);
         }

         xml.Save(Application.StartupPath + "\\temp.xml");
      }

      private void button4_Click(object sender, EventArgs e)
      {
         XmlDocument xml = new XmlDocument();
         xml.Load(Application.StartupPath + "\\family.xml");

         XmlNodeList nodeList = xml.GetElementsByTagName("name");

         foreach (XmlNode node in nodeList)
         {
            textBox1.Text += node.InnerText + "\r\n";            
         }

         nodeList = xml.GetElementsByTagName("member");

         foreach (XmlNode node in nodeList)
         {
            textBox1.Text += node.Attributes["no"].Value + "\r\n";
         }
      }

      private void button5_Click(object sender, EventArgs e)
      {
         XmlReaderSettings settings = new XmlReaderSettings();
         settings.ProhibitDtd = false;
         settings.ValidationType = ValidationType.DTD;

         XmlReader reader = XmlReader.Create(Application.StartupPath + "\\family.xml", settings);

         reader.ReadStartElement("family");
         reader.ReadStartElement("member");
         reader.ReadStartElement("name");

         textBox1.Text += reader.ReadString();

         reader.Close();
      }

      private void button6_Click(object sender, EventArgs e)
      {
         XmlDocument xml = new XmlDocument();
         xml.Load(Application.StartupPath + "\\family.xml");

         XmlNodeList nodeList = xml.GetElementsByTagName("name");

         foreach (XmlNode node in nodeList)
         {
            node.InnerText = "new Name";
         }

         nodeList = xml.GetElementsByTagName("member");

         foreach (XmlNode node in nodeList)
         {
            node.Attributes["no"].Value = "-1";
         }

         xml.Save(Application.StartupPath + "\\temp.xml");
      }
   }
}