﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Data" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

   protected void Page_Load(object sender, EventArgs e)
   {
      if (!Page.IsPostBack)
         BindData();
   }

   private void BindData()
   {
      SqlConnection connection = new SqlConnection();
      connection.ConnectionString = ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString;

      SqlCommand selectCommand = new SqlCommand("select * from Customers", connection);
      SqlDataAdapter dataAdapter = new SqlDataAdapter();
      dataAdapter.SelectCommand = selectCommand;
      DataSet dataSet = new DataSet();
      dataAdapter.Fill(dataSet, "Kunden");

      GridView1.DataSource = dataSet.Tables["Kunden"];
      GridView1.DataBind();
   }
   
   protected void GridView1_RowEditing(object sender, GridViewEditEventArgs e)
   {
      GridView1.EditIndex = e.NewEditIndex;
      BindData();
   }

   protected void GridView1_RowUpdating(object sender, GridViewUpdateEventArgs e)
   {
      string newCompanyName = ((TextBox)GridView1.Rows[e.RowIndex].FindControl("TextBox1")).Text;
      string customerID = GridView1.DataKeys[0].Value.ToString();
      
      SqlConnection connection = new SqlConnection();
      connection.ConnectionString = ConfigurationManager.ConnectionStrings["MySQLServer"].ConnectionString;

      SqlCommand updateCommand = new SqlCommand("update Customers set CompanyName = @CompanyName where CustomerID = @CustomerID");
      updateCommand.Connection = connection;
      
      updateCommand.Parameters.AddWithValue("@CompanyName", newCompanyName);
      updateCommand.Parameters.AddWithValue("@CustomerID", customerID);

      connection.Open();      
      updateCommand.ExecuteNonQuery();
      connection.Close();
   }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Unbenannte Seite</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
       <asp:GridView 
         ID="GridView1" 
         runat="server" 
         OnRowEditing="GridView1_RowEditing" 
         DataKeyNames="CustomerID" 
         OnRowUpdating="GridView1_RowUpdating" 
         AutoGenerateColumns="False">
          <Columns>
             <asp:CommandField ShowEditButton="True" />
             <asp:TemplateField>
                <EditItemTemplate>
                   <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("CompanyName") %>'></asp:TextBox>
                </EditItemTemplate>
                <ItemTemplate>
                   <asp:Label ID="Label1" runat="server" Text='<%# Bind("CompanyName") %>'></asp:Label>
                </ItemTemplate>
             </asp:TemplateField>
             <asp:TemplateField>
                <EditItemTemplate>
                   <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("ContactName") %>'></asp:TextBox>
                </EditItemTemplate>
                <ItemTemplate>
                   <asp:Label ID="Label2" runat="server" Text='<%# Bind("ContactName") %>'></asp:Label>
                </ItemTemplate>
             </asp:TemplateField>
             <asp:TemplateField>
                <EditItemTemplate>
                   <asp:TextBox ID="TextBox3" runat="server" Text='<%# Bind("Address") %>'></asp:TextBox>
                </EditItemTemplate>
                <ItemTemplate>
                   <asp:Label ID="Label3" runat="server" Text='<%# Bind("Address") %>'></asp:Label>
                </ItemTemplate>
             </asp:TemplateField>
          </Columns>
       </asp:GridView>
    
    </div>
    </form>
</body>
</html>
