﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Data.Linq;         //System.Data.Linq.dll als Referenz 
                                //einbinden
using System.Data.Linq.Mapping; //Zum erzeugen von Table-Mappings, 
                                //Attribut Table(Name = "name")
using System.Reflection;

namespace LINQ2SQL01
{
    public class Program
    {
        #region Einfache Abfragen
        [Table(Name = "Customers")]
        public class Customer
        {
            [Column(Name = "CustomerID")]
            public string CustomerID;
            //Felder
            [Column(Name = "Country")]
            public string CountryName;
            //Benutzerdef. Feld
            public int userDefinedField = 77;
        }
        #endregion

        #region Direkte Abfragen
        //[Table(Name = "Customers")]
        //public class Customer
        //{
        //    //Primary Key
        //    [Column(Name = "CustomerID", IsPrimaryKey = true)]
        //    public string CustomerID;
        //    //Felder
        //    [Column(Name = "Country")]
        //    public string CountryName;
        //    //Benutzerdef. Feld
        //    public int userDefinedField = 77;
        //}
        #endregion

        #region Fremdschlüsselbeziehung
        //[Table(Name = "Customers")]
        //public class Customer
        //{
        //    //Primary Key
        //    [Column(Name = "CustomerID", IsPrimaryKey = true)]
        //    public string CustomerID;
        //    //Felder
        //    [Column(Name = "Country")]
        //    public string CountryName;

        //    //Benutzerdef. Feld
        //    public int userDefinedField = 77;
        //}

        //[Table(Name = "Orders")]
        //public class Order
        //{
        //    //Primary Key
        //    [Column(Name = "OrderID", IsPrimaryKey = true)]
        //    public int OrderID;
        //    //Foreign Key
        //    [Column(Name = "CustomerID")]
        //    public string CustomerID;
        //    //Felder
        //    [Column(Name = "ShipCity")]
        //    public string ShipCity;
        //    //Fremdschlüssel zu Customer über CustomerID
        //    private EntityRef<Customer> refCustomer;
        //    [Association(Storage = "refCustomer", ThisKey = "CustomerID")]
        //    public Customer Cust
        //    {
        //        get { return this.refCustomer.Entity; }
        //        set { this.refCustomer.Entity = value; }
        //    }
        //}
        #endregion

        #region Primärschlüsselbeziehung
        //[Table(Name = "Customers")]
        //public class Customer
        //{
        //    //Primary Key
        //    [Column(Name = "CustomerID", IsPrimaryKey = true)]
        //    public string CustomerID;
        //    //Felder
        //    [Column(Name = "Country")]
        //    public string CountryName;

        //    //Benutzerdef. Feld
        //    public int userDefinedField = 77;

        //    //Primärschlüsselverknüpfung
        //    [Association(OtherKey = "CustomerID")]
        //    public EntitySet<Order> Orders;
        //}

        //[Table(Name = "Orders")]
        //public class Order
        //{
        //    //Primary Key
        //    [Column(Name = "OrderID", IsPrimaryKey = true)]
        //    public int OrderID;
        //    //Foreign Key
        //    [Column(Name = "CustomerID")]
        //    public string CustomerID;
        //    //Felder
        //    [Column(Name = "ShipCity")]
        //    public string ShipCity;
        //}
        #endregion

        #region Gespeicherte Prozedur
        //[Table(Name = "Customers")]
        //public class Customer
        //{
        //    [Column(Name = "CustomerID")]
        //    public string CustomerID;
        //    [Column(Name="CompanyName")]
        //    public string CompanyName;
        //}

        //[Table(Name = "Orders")]
        //public class Order
        //{
        //    [Column(Name = "OrderID")]
        //    public int OrderID;
        //    [Column(Name = "ShipName")]
        //    public string ShipName;
        //}

        //public class GetCustomerByCountry : DataContext
        //{
        //    public GetCustomerByCountry(string fileOrServerOrConnection)
        //        : base(fileOrServerOrConnection)
        //    { }

        //    //[Function(Name="GetCustomerByCountry")]
        //    //public ISingleResult<Customer> _GetCustomerByCountry
        //    //(
        //    //    [Parameter(Name="Country", DbType="NVarChar")]
        //    //    System.String country
        //    //)
        //    //{
        //    //    IExecuteResult result = this.ExecuteMethodCall
        //    //    (
        //    //        this,
        //    //        ((MethodInfo)(MethodInfo.GetCurrentMethod())),
        //    //        country
        //    //    );
        //    //    return ((ISingleResult<Customer>)(result.ReturnValue));
        //    //}

        //    [Function(Name = "GetCustomerByCountry")]
        //    [ResultType(typeof(Customer))]
        //    [ResultType(typeof(Order))]
        //    public IMultipleResults _GetCustomerOrOrderByCountry
        //    (
        //        [Parameter(Name = "Country", DbType = "NVarChar")]
        //        System.String country
        //    )
        //    {
        //        IExecuteResult results = this.ExecuteMethodCall
        //        (
        //            this,
        //            ((MethodInfo)(MethodInfo.GetCurrentMethod())),
        //            country
        //        );

        //        return ((IMultipleResults)(results.ReturnValue));
        //    }
        //}
        #endregion

        #region Kompilierte Abfragen
        //[Table(Name = "Customers")]
        //public class Customer
        //{
        //    //Primary Key
        //    [Column(Name = "CustomerID", IsPrimaryKey = true)]
        //    public string CustomerID;
        //    //Felder
        //    [Column(Name = "Country")]
        //    public string CountryName;
        //}
        #endregion


        public static void Main(string[] args)
        {
            //DataContext dc = new DataContext(@"C:\Beispiele\Northwind Datenbank\NORTHWND.MDF");
            DataContext dc = new DataContext(@"Data Source=(local)\SQLExpress;AttachDbFilename=C:\Beispiele\Northwind Datenbank\NORTHWND.MDF;Initial Catalog=Northwind;Integrated Security=True");
           
            if (!dc.DatabaseExists())
                return;

   
            #region Einfache Abfrage
            Table<Customer> mapCustomer = dc.GetTable<Customer>();

            var query1 =
                from c in mapCustomer
                where c.CountryName == "Germany"
                select new { c.CustomerID, c.userDefinedField };

            foreach (var item in query1)
            {
                Console.WriteLine(item.CustomerID);
            }
            #endregion

            #region Fremdschlüsselbeziehung - Ausgabe
            //Table<Customer> mapCustomer = dc.GetTable<Customer>();
            //Table<Order> mapOrders = dc.GetTable<Order>();

            //var query2 =
            //    (
            //        from o in mapOrders
            //        where o.ShipCity == "Reims"
            //        select o
            //    ).Distinct();

            //foreach (var item in query2)
            //{
            //    Console.WriteLine(item.Cust.CustomerID + " " + item.OrderID);
            //}
            #endregion

            #region Primärschlüsselbeziehung - Ausgabe
            //Table<Customer> mapCustomer = dc.GetTable<Customer>();
            //Table<Order> mapOrders = dc.GetTable<Order>();

            //var query3 =
            //    from c in mapCustomer
            //    where c.CountryName == "Germany"
            //    select c;

            //foreach (var item in query3)
            //{
            //    Console.WriteLine(item.CustomerID + " " + item.CountryName);
            //    foreach (var item2 in item.Orders)
            //    {
            //        Console.WriteLine("\t" + item2.OrderID + " " + item2.ShipCity);
            //    }
            //}
            #endregion

            #region Gespeicherte Prozedur - Ausgabe
            //Table<Customer> mapCustomer = dc.GetTable<Customer>();
            //Table<Order> mapOrders = dc.GetTable<Order>();

            //GetCustomerByCountry results = new GetCustomerByCountry(@"C:\Beispiele\Northwind Datenbank\NORTHWND.MDF");

            //IMultipleResults r = results._GetCustomerOrOrderByCountry("Germany");

            //foreach (var item in r.GetResult<Customer>())
            //{
            //    Console.WriteLine(item.CustomerID + " " + item.CompanyName);
            //}

            //foreach (var item in r.GetResult<Order>())
            //{
            //    Console.WriteLine(item.OrderID + " " + item.ShipName);
            //}
            #endregion

            #region Kompilierte Abfrage - Ausgabe
            //Table<Customer> mapCustomer = dc.GetTable<Customer>();

            //var query1 = CompiledQuery.Compile
            //    (
            //        (DataContext context, string p1) =>
            //        from c in mapCustomer
            //        where c.CountryName == p1
            //        select new { c.CustomerID, c.CountryName }
            //    );

            //foreach (var item in query1(dc, "Germany"))
            //{
            //    Console.WriteLine(item.CustomerID + " " + item.CountryName);
            //}           
            #endregion

            #region Direkte Abfragen - Ausgabe
            //var query =
            //    dc.ExecuteQuery<Customer>
            //    (@"
            //        select
            //            *
            //        from
            //            Customers
            //        where
            //            Country = {0}
            //    ", new object[] { "Germany" }
            //    );

            //foreach (var item in query)
            //{
            //    Console.WriteLine(item.CustomerID + " " + item.CountryName);
            //}
            #endregion

            Console.ReadLine();
        }
    }
}
