﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Reflection;

using System.Transactions;

namespace LINQ2SQL02
{
    public class Program
    {
        [Table(Name = "Customers")]
        public class Customer
        {
            [Column(Name = "CustomerID", IsPrimaryKey = true, UpdateCheck=UpdateCheck.Always)]
            public string CustomerID;
            [Column(Name = "CompanyName", UpdateCheck=UpdateCheck.Never)]
            public string CompanyName;
            [Column(Name = "Country", UpdateCheck=UpdateCheck.WhenChanged)]
            public string CountryName;
        }

        public static void Main(string[] args)
        {
            //DataContext dc = new DataContext(@"C:\Beispiele\Northwind Datenbank\NORTHWND.MDF");
            DataContext dc = new DataContext(@"Data Source=(local)\SQLExpress;AttachDbFilename=C:\Beispiele\Northwind Datenbank\NORTHWND.MDF;Initial Catalog=Northwind;Integrated Security=True");

            if (!dc.DatabaseExists())
                return;

            dc.ObjectTrackingEnabled = true;


            #region Ändern von Daten
            Table<Customer> mapCustomer = dc.GetTable<Customer>();

            var query1 =
                from c in mapCustomer
                where c.CountryName == "Germany"
                select new { c.CustomerID, c.CompanyName};

            var customer = mapCustomer.Single(c => c.CustomerID == "ALFKI");
            customer.CompanyName = "Other Company Name";

            dc.SubmitChanges();

            foreach (var item in query1)
            {
                Console.WriteLine(item.CustomerID + " " + item.CompanyName);
            }
            #endregion

            #region Hinzufügen von Daten
            //Table<Customer> mapCustomer = dc.GetTable<Customer>();

            //var customerAdd =
            //    new Customer
            //    {
            //        CustomerID = "AARON",
            //        CompanyName = "Kirchberger Hof",
            //        CountryName = "Germany"
            //    };

            ////Hinzufügen
            //mapCustomer.InsertOnSubmit(customerAdd);

            //dc.SubmitChanges();

            //var query2 =
            //    from c in mapCustomer
            //    where c.CountryName == "Germany"
            //    select new { c.CustomerID, c.CompanyName };

            //foreach (var item in query2)
            //{
            //    Console.WriteLine(item.CustomerID + " " + item.CompanyName);
            //}

            ////Löschen
            //var customerDelete =
            //    mapCustomer.Single(c => c.CustomerID == "AARON");

            //mapCustomer.DeleteOnSubmit(customerDelete);

            //dc.SubmitChanges();

            //foreach (var item in query2)
            //{
            //    Console.WriteLine(item.CustomerID + " " + item.CompanyName);
            //}
            #endregion

            #region Konflikterkennung
            //Table<Customer> mapCustomer = dc.GetTable<Customer>();

            //var customerAdd =
            //    new Customer
            //    {
            //        CustomerID = "AARON",
            //        CompanyName = "Kirchberger Hof",
            //        CountryName = "Germany"
            //    };

            //mapCustomer.InsertOnSubmit(customerAdd);

            //try
            //{
            //    dc.SubmitChanges();
            //    //dc.SubmitChanges(ConflictMode.FailOnFirstConflict);
            //    //dc.SubmitChanges(ConflictMode.ContinueOnConflict);
            //}
            //catch (ChangeConflictException e)
            //{
            //    Console.WriteLine(e.Message);

            //}
            #endregion

            #region Transaktionen
            //Table<Customer> mapCustomer = dc.GetTable<Customer>();

            //var customerAdd =
            //    new Customer
            //    {
            //        CustomerID = "AARON",
            //        CompanyName = "Kirchberger Hof",
            //        CountryName = "Germany"
            //    };

            //mapCustomer.InsertOnSubmit(customerAdd);

            //// Transaktion durchführen
            //try
            //{
            //    using (TransactionScope transactionScope = new TransactionScope())
            //    {
            //        dc.SubmitChanges();
            //        transactionScope.Complete();
            //    }
            //}
            //catch (ChangeConflictException e)
            //{
            //    Console.WriteLine(e.Message);
            //}

            //// Ergebnis anaschauen
            //var query1 =
            //    from c in mapCustomer
            //    where c.CountryName == "Germany"
            //    select new { c.CustomerID, c.CompanyName };
            //foreach (var item in query1)
            //{
            //    Console.WriteLine(item.CustomerID + " " + item.CompanyName);
            //}


            //// alten Zustand der Datenbank wiederherstellen
            //var customerDelete =
            //    mapCustomer.Single(c => c.CustomerID == "AARON");

            //mapCustomer.DeleteOnSubmit(customerDelete);
            //dc.SubmitChanges();

            #endregion
            Console.ReadLine();
        }
    }
}
