using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Drawing;

namespace Quiz
{
    class Question
    {
        private string question;
        private string option1;
        private string option2;
        private string option3;
        private string option4;
        private int solution;

        public Question(System.String f, System.String o1, System.String o2, System.String o3, System.String o4, int l)
        {
            question = f;
            option1 = o1;
            option2 = o2;
            option3 = o3;
            option4 = o4;
            solution = l;
        }

        public virtual void Display(MQ_Form form)
        {
            form.question.Text = question;
            form.answer1.Text = option1;
            form.answer2.Text = option2;
            form.answer3.Text = option3;
            form.answer4.Text = option4;
        }

        public virtual bool Evaluate(int chosen)
        {
            if (chosen == this.solution)
                return true;
            else
                return false;
        }
    }

    class GameLogic
    {
        internal const int NUM_QUESTIONS = 8;
        internal const int CONTROLS_BIAS = 7; 

        internal Question[] questions;
        internal sbyte currQuestion = 0;
        internal int winlevel = 0;

        internal GameLogic()
        {
            questions = new Question[NUM_QUESTIONS];

            questions[0] = new Question("Ist C# ...", "desorientiert", "objektorientiert", "blamiert", "pervertiert", 2);
            questions[1] = new Question("Welche Sprache kann als Ahn von C# angesehen werden?", "Pascal", "Java", "Simula", "Smalltalk", 4);
            questions[2] = new Question("Mit welchem Schlsselwort werden in C# Objekte erzeugt?", "new", "create", "erzeuge", "old", 1);
            questions[3] = new Question("Mit welchem Schlsselwort werden in C# konstante Variablen deklariert?", "konstant", "final", "const", "immutable", 3);
            questions[4] = new Question("Wie lautet der Wert folgenden Ausdrucks: \n2d + 3 / 4?", "2", "2.75", "3", "1.25", 1);
            questions[5] = new Question("Nach welchem Algorithmus sortiert Array.Sort() Objekte?", "Bubblesort", "Shellsort", "Mergesort", "Quicksort", 4);
            questions[6] = new Question("Seit welcher Version gibt es C#-Generika?", "1.0", "1.1", "2.0", "3.0", 3);
            questions[7] = new Question("Seit wann gibt es die Firma Microsoft?", "1843", "1945", "1975", "1985", 3);
        }

        internal virtual void Evaluate(int schalter, MQ_Form form)
        {
            Label tmp;

            if (!questions[currQuestion].Evaluate(schalter))
            {
                // falsch beantwortet
                if (winlevel == 0)
                    MessageBox.Show("Leider nichts gewonnen.  :-(", "Schade!");
                else
                    MessageBox.Show("Sie haben winlevel " + winlevel + " erreicht!  :-)", "Glckwunsch!!!");

                // Schalter deaktivieren
                form.answer1.Enabled = false;
                form.answer2.Enabled = false;
                form.answer3.Enabled = false;
                form.answer4.Enabled = false;
            }
            else if (currQuestion < NUM_QUESTIONS - 1)
            {           
                questions[++currQuestion].Display(form);

                tmp = (Label)form.Controls[winlevel + CONTROLS_BIAS];
                tmp.ForeColor = Color.FromArgb(0x00FFFF);
                winlevel++;
            }
            else
            {
                tmp = (Label)form.Controls[winlevel + CONTROLS_BIAS];
                tmp.ForeColor = Color.FromArgb(0x00FFFF);
                winlevel++;
                MessageBox.Show("Glckwunsch, Sie haben den Jackpot geknackt!!!", "Wow!!!");

                // Schalter deaktivieren
                form.answer1.Enabled = false;
                form.answer2.Enabled = false;
                form.answer3.Enabled = false;
                form.answer4.Enabled = false;
            }
        }
    }
}
